import * as i0 from '@angular/core';
import { Directive, Input, HostListener, NgModule } from '@angular/core';
import PerfectScrollbar from 'perfect-scrollbar';
import * as i1 from '@angular/router';
import { NavigationEnd, NavigationError, NavigationCancel } from '@angular/router';
import { filter, delay } from 'rxjs/operators';

class PerfectScrollbarDirective {
    constructor(_elementRef, _router) {
        this._elementRef = _elementRef;
        this._router = _router;
        this.allSub = new Array();
        this.options = {};
    }
    set perfectScrollOptions(value) {
        this.options = value;
    }
    onResize() {
        this.psUpdate();
    }
    ngAfterViewInit() {
        this.initPerfectScroll();
        const navigationEnd$ = this._router.events
            .pipe(filter((event) => event instanceof NavigationEnd || event instanceof NavigationError || event instanceof NavigationCancel), delay(100))
            .subscribe(() => {
            this.psUpdate();
        });
        this.allSub.push(navigationEnd$);
    }
    initPerfectScroll() {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
        this.ps = new PerfectScrollbar(this._elementRef.nativeElement, {});
    }
    psUpdate() {
        this.ps && this.ps.update();
    }
    ngOnDestroy() {
        this.ps && this.ps.destroy();
        this.allSub.forEach(x => x.unsubscribe());
    }
}
PerfectScrollbarDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: PerfectScrollbarDirective, deps: [{ token: i0.ElementRef }, { token: i1.Router }], target: i0.ɵɵFactoryTarget.Directive });
PerfectScrollbarDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.11", type: PerfectScrollbarDirective, selector: "[perfectScrollbar]", inputs: { perfectScrollOptions: "perfectScrollOptions" }, host: { listeners: { "window:resize": "onResize()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: PerfectScrollbarDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[perfectScrollbar]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i1.Router }]; }, propDecorators: { perfectScrollOptions: [{
                type: Input
            }], onResize: [{
                type: HostListener,
                args: ['window:resize']
            }] } });

class PerfectScrollbarModule {
}
PerfectScrollbarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: PerfectScrollbarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
PerfectScrollbarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.11", ngImport: i0, type: PerfectScrollbarModule, declarations: [PerfectScrollbarDirective], exports: [PerfectScrollbarDirective] });
PerfectScrollbarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: PerfectScrollbarModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: PerfectScrollbarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        PerfectScrollbarDirective
                    ],
                    exports: [
                        PerfectScrollbarDirective
                    ]
                }]
        }] });

/*
 * Public API Surface of perfect-scrollbar
 */

/**
 * Generated bundle index. Do not edit.
 */

export { PerfectScrollbarDirective, PerfectScrollbarModule };
//# sourceMappingURL=ngartifex-perfect-scrollbar.mjs.map
